#include "simulation.h"
#include "random.h"
//-------------------------------SHO demo: OK
class TObsluha;

CHead *Fronta;
TObsluha *Obsluha;


class TPozadavek:public CProcess	// objekt Pozadavek 
{
public:
  virtual void Run ();		// telo procesu
};


class TObsluha:public CProcess	// objekt Obsluha -
{
public:
  virtual void Run ();		// telo procesu

};

void
TPozadavek::Run ()		// telo procesu TPozadavek
{
  printf ("Prichod %f\n", Time ());
  (new TPozadavek)->ActivateDelay (70);	// zavleceni dalsiho pozadavku
  if (Fronta->Empty ())
    {
      Into (Fronta);		// zaradi se do fronty
      Obsluha->ActivateAt (Time ());
    }				// je-li prvni, zavola obsluhu
  else
    Into (Fronta);		// zaradi se do fronty a ceka
  Passivate ();			// ceka na dokonceni obsluhy
  printf ("Odchod %f\n", Time ());
  // delete this;
  Passivate ();
}


void
TObsluha::Run ()		// telo procesu TObsluha
{
  CProcess *P;
  while (1)
    {
      printf ("Zacatek obsluhy v case %f\n", Time ());
      Hold (negexp (0.1));	// doba obsluhy   
      P = (CProcess *) Fronta->First ();
      P->Out ();		// vyber obslouzeneho pozadavku z fronty,   
      P->ActivateAt (Time ());
      printf ("Konec obsluhy v case %f\n", Time ());
      if (Fronta->Empty ())
	Passivate ();
    }
}

/*----------------------------------------------*/
void
CSimulation::Run ()		// hlavni proces
{
  printf ("--- Ukazka pouziti modulu SIMULATION --cas %f\n", Time ());

  Obsluha = new TObsluha ();	// vytvoreni objektu Obsluha
  Fronta = new CHead ();	// vytvoreni fronty Fronta
  (new TPozadavek)->ActivateAt (Time ());	// vytvoreni a naplanovani prvniho pozadavku

  Hold (100);			// celkova doba simulace
  printf ("Delka fronty: %ld\n\n", Fronta->Cardinal ());
  printf ("Konec simulace---cas: %f\n\n", Time ());
};
